﻿namespace PublishingBeacon
{
  using Windows.Devices.Bluetooth.Advertisement;
  using Windows.Storage.Streams;
  using Windows.UI.Xaml;
  using Windows.UI.Xaml.Controls;

  public sealed partial class MainPage : Page
  {
    public MainPage()
    {
      this.InitializeComponent();
      this.Loaded += OnLoaded;
    }
    void OnLoaded(object sender, RoutedEventArgs e)
    {
      // Here's an imaginary UK car registration number (from Wikipedia)
      string carReg = "BD51 SMR";
      DataWriter writer = new DataWriter();
      writer.WriteInt32(carReg.Length);
      writer.WriteString(carReg);

      // Let's pretend we're Audi. 0x010E is their company identifier.
      var manufacturerData = new BluetoothLEManufacturerData(
        0x010E, writer.DetachBuffer());

      this.publisher = new BluetoothLEAdvertisementPublisher();

      this.publisher.Advertisement.ManufacturerData.Add(manufacturerData);

      this.txtCarReg.Text = carReg;

      this.publisher.Start();
    }
    BluetoothLEAdvertisementPublisher publisher;
  }
}